﻿Option Strict On
Option Explicit On
Option Infer Off

Imports System.Threading

Module Module1

    Private r As Random = New Random()

    Sub Main()
        'uruchamianieObliczenPi()

        Dim ts As ThreadStart = New ThreadStart(AddressOf uruchamianieObliczenPi)
        Dim t As Thread = New Thread(ts)
        't.IsBackground = True
        t.Priority = ThreadPriority.Highest
        t.Start()
        'Thread.Sleep(500)
        Console.WriteLine("Czy ten napis pojawi się przed otrzymaniem wyniku?")
    End Sub

    Private Function obliczPi(ilośćPrób As Long) As Double
        Dim x, y As Double
        Dim ilośćTrafień As Long = 0
        For i As Long = 0 To ilośćPrób - 1
            x = r.NextDouble()
            y = r.NextDouble()
            If x * x + y * y < 1 Then ilośćTrafień += 1
            'Console.WriteLine("x={0}, y={1}", x, y)
        Next
        Return 4.0 * ilośćTrafień / ilośćPrób
    End Function

    Private Sub uruchamianieObliczenPi()
        Try
            Console.WriteLine("Uruchamianie obliczeń, wątek nr {0}...",
                  Thread.CurrentThread.ManagedThreadId)

            Dim czasPoczatkowy As Integer = Environment.TickCount

            Dim ilośćPrób As Long = 10000000L
            Dim pi As Double = obliczPi(ilośćPrób)
            'Console.WriteLine("Pi={0}, błąd={1}", pi, Math.Abs(Math.PI - pi))
            Console.WriteLine("Pi={0}, błąd={1}, wątek nr {2}",
                      pi, Math.Abs(Math.PI - pi),
                      Thread.CurrentThread.ManagedThreadId)

            Dim czasKoncowy As Integer = Environment.TickCount
            Dim roznica As Integer = czasKoncowy - czasPoczatkowy
            Console.WriteLine("Czas obliczeń: " & (roznica).ToString())
        Catch exc As ThreadAbortException
            Console.WriteLine("Działanie wątku zostało przerwane (" & exc.Message & ")")
        Catch exc As Exception
            Console.WriteLine("Wyjątek (" & exc.Message & ")")
        End Try
    End Sub
End Module
